﻿Public Class SportsCar
    Inherits Vehicle

    'フィールド==========
    Public Const MAXSPEED As Integer = 300      '最大スピード
    Public Const MAXFUEL As Double = 60         'ガソリンタンク容量

    'コンストラクタ==========
    Public Sub New(gas As Double)
        MyBase.New(gas)
        'ガソリン量が容量を超える場合は、最大容量をガソリン量にセット
        If Me.Gas > MAXFUEL Then
            Me.Gas = MAXFUEL
        End If
    End Sub

    'メソッド==========
    Public Overrides Sub SpeedUp(sp As Integer)
        'ガソリンを減らす
        Me.Gas -= sp / 10.0
        If Me.Gas < 0 Then      'ガソリンがマイナスになる場合
            'ガソリンを0に補正し、スピードを増やさない
            Me.Gas = 0
        Else
            'スピードを増やす
            Me.Speed += sp
            If Me.Speed > MAXSPEED Then     '最大スピードに達した場合
                '最大スピードをセットする
                Me.Speed = MAXSPEED
            End If
        End If
    End Sub
End Class
